import { Orm, ModelBase } from '@spinajs/orm';
import { IRouteParameter, IRouteCall, ParameterType, ArgHydrator, Request as sRequest, RouteArgs } from '@spinajs/http';
import { IContainer, Bootstrapper } from '@spinajs/di';
import { FromModelOptions } from './interfaces.js';
export * from './interfaces.js';
export * from './model.js';
export * from './decorators.js';
export * from './extension.js';
export * from './route-arg.js';
export * from './builders.js';
export * from './dto.js';
export * from './response-methods/OrmNotFound.js';
export declare class AsDbModel extends RouteArgs {
    get SupportedType(): string;
    extract(callData: IRouteCall, _args: unknown[], param: IRouteParameter, req: sRequest): Promise<{
        CallData: IRouteCall;
        Args: ModelBase<unknown>;
    }>;
}
export declare class FromDbModel extends RouteArgs {
    protected Container: IContainer;
    protected Orm: Orm;
    resolve(): Promise<void>;
    get SupportedType(): string;
    extract(callData: IRouteCall, args: unknown[], param: IRouteParameter, req: sRequest): Promise<{
        CallData: IRouteCall;
        Args: any;
    }>;
    protected _extractValue(param: IRouteParameter<FromModelOptions<ModelBase>>, req: sRequest): any;
    protected fromDbModelDefaultQueryFunction(callData: IRouteCall, _args: unknown[], param: IRouteParameter<FromModelOptions<ModelBase>>, req: sRequest): Promise<any>;
}
export declare class DbModelHydrator extends ArgHydrator {
    hydrate(input: any, parameter: IRouteParameter): Promise<any>;
}
export declare function AsModel(field?: string, type?: ParameterType): (target: any, propertyKey?: string | symbol, indexOrDescriptor?: number | PropertyDescriptor) => void;
export declare function FromModel(options?: FromModelOptions<ModelBase<any>>): (target: any, propertyKey?: string | symbol, indexOrDescriptor?: number | PropertyDescriptor) => void;
export declare class OrmHttpBootstrapper extends Bootstrapper {
    bootstrap(): Promise<void>;
}
//# sourceMappingURL=index.d.ts.map