"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrmHttpBootstrapper = exports.FromModel = exports.AsModel = exports.DbModelHydrator = exports.FromDbModel = exports.AsDbModel = void 0;
const orm_1 = require("@spinajs/orm");
const http_1 = require("@spinajs/http");
const di_1 = require("@spinajs/di");
const model_js_1 = require("./model.js");
const exceptions_1 = require("@spinajs/exceptions");
__exportStar(require("./interfaces.js"), exports);
__exportStar(require("./model.js"), exports);
__exportStar(require("./decorators.js"), exports);
__exportStar(require("./extension.js"), exports);
__exportStar(require("./route-arg.js"), exports);
__exportStar(require("./builders.js"), exports);
__exportStar(require("./dto.js"), exports);
__exportStar(require("./response-methods/OrmNotFound.js"), exports);
let AsDbModel = class AsDbModel extends http_1.RouteArgs {
    get SupportedType() {
        return 'AsDbModel';
    }
    async extract(callData, _args, param, req) {
        if (!req.body) {
            return { CallData: callData, Args: null };
        }
        const result = new param.RuntimeType();
        const data = req.body[param.Options.field ?? param.Name];
        if (!data) {
            throw new orm_1.OrmException(`Cannot hydrate model, field ${param.Options.field ?? param.Name} is required`);
        }
        result.hydrate(data);
        return { CallData: callData, Args: result };
    }
};
exports.AsDbModel = AsDbModel;
exports.AsDbModel = AsDbModel = __decorate([
    (0, di_1.Injectable)()
], AsDbModel);
let FromDbModel = class FromDbModel extends http_1.RouteArgs {
    async resolve() { }
    get SupportedType() {
        return 'FromDB';
    }
    async extract(callData, args, param, req) {
        let result = null;
        if (param?.Options?.query) {
            result = await param.Options.query.call(param.RuntimeType.query(), args, this._extractValue(param, req)).firstOrThrow(new orm_1.OrmNotFoundException("Resource not found"));
            ;
        }
        else {
            result = await this.fromDbModelDefaultQueryFunction(callData, args, param, req);
        }
        return { CallData: callData, Args: result };
    }
    _extractValue(param, req) {
        let pkValue = null;
        const field = param?.Options?.paramField ?? param.Name;
        switch (param?.Options?.paramType) {
            case http_1.ParameterType.FromQuery:
                pkValue = req.query[field];
                break;
            case http_1.ParameterType.FromBody:
                pkValue = req.body ? req.body[field] : null;
                break;
            case http_1.ParameterType.FromHeader:
                pkValue = req.headers[field.toLowerCase()];
                break;
            case http_1.ParameterType.FromParams:
            default:
                pkValue = req.params[field];
                break;
        }
        return pkValue;
    }
    fromDbModelDefaultQueryFunction(callData, _args, param, req) {
        const pkValue = this._extractValue(param, req);
        const query = param.RuntimeType['query']();
        const descriptor = (0, orm_1.extractModelDescriptor)(param.RuntimeType);
        const queryField = param?.Options?.queryField ?? descriptor.PrimaryKey;
        query.select('*');
        query.where(queryField, pkValue);
        /**
         * Checks BelongsToRelations
         */
        for (const [, v] of descriptor.Relations) {
            // if its one-to-one relations ( belongsTo)
            // check if we have same field in route param list
            // If exists, we assume that we want parent ( owner of this model )
            if (v.Type === orm_1.RelationType.One) {
                const args = callData.Payload?.Param?.Args;
                if (args) {
                    const keys = Object.keys(args);
                    const key = keys.find((k) => {
                        return k.toLowerCase() === v.Name.toLowerCase() || k.toLowerCase() === `_${v.Name.toLowerCase()}`;
                    });
                    if (key) {
                        if (callData.Payload.Param.Args[key]) {
                            query.where(v.ForeignKey, callData.Payload.Param.Args[key]);
                        }
                        else {
                            throw new exceptions_1.InvalidArgument(`no key for relation ${v.Name} was provided`);
                        }
                    }
                }
            }
        }
        /**
      * Checks include field
      */
        if (param.Options?.noInclude === true) {
            return query.firstOrThrow(new orm_1.OrmNotFoundException("Resource not found"));
        }
        /**
         * Checks include field
         */
        if (callData.Payload?.Query?.Args?.include || callData.Payload?.Query?.Args?._include) {
            query.populate(callData.Payload.Query.Args.include ?? callData.Payload.Query.Args._include);
        }
        return query.firstOrThrow(new orm_1.OrmNotFoundException("Resource not found"));
    }
};
exports.FromDbModel = FromDbModel;
__decorate([
    (0, di_1.Autoinject)(di_1.Container),
    __metadata("design:type", Object)
], FromDbModel.prototype, "Container", void 0);
__decorate([
    (0, di_1.Autoinject)(orm_1.Orm),
    __metadata("design:type", orm_1.Orm)
], FromDbModel.prototype, "Orm", void 0);
exports.FromDbModel = FromDbModel = __decorate([
    (0, di_1.Injectable)()
], FromDbModel);
class DbModelHydrator extends http_1.ArgHydrator {
    async hydrate(input, parameter) {
        if (input === null) {
            throw new orm_1.OrmException('primary key cannot be null');
        }
        const model = new parameter.RuntimeType();
        model.hydrate(input);
        return model;
    }
}
exports.DbModelHydrator = DbModelHydrator;
function AsModel(field, type) {
    return (0, http_1.Route)((0, http_1.Parameter)('AsDbModel', null, { field, type }));
}
exports.AsModel = AsModel;
function FromModel(options) {
    return (0, http_1.Route)((0, http_1.Parameter)('FromDbModel', null, options));
}
exports.FromModel = FromModel;
let OrmHttpBootstrapper = class OrmHttpBootstrapper extends di_1.Bootstrapper {
    async bootstrap() {
        di_1.DI.once('di.resolved.Orm', (_, orm) => {
            // set default route parameter hydrator for all loaded models
            orm.Models.forEach((m) => {
                Reflect.defineMetadata('custom:arg_hydrator', { hydrator: DbModelHydrator }, m.type);
            });
            // add custom mixins
            orm.Models.forEach((m) => {
                // tslint:disable-next-line: forin
                for (const mixin in model_js_1.MODEL_STATIC_MIXINS) {
                    m.type[mixin] = model_js_1.MODEL_STATIC_MIXINS[mixin].bind(m.type);
                }
            });
        });
    }
};
exports.OrmHttpBootstrapper = OrmHttpBootstrapper;
exports.OrmHttpBootstrapper = OrmHttpBootstrapper = __decorate([
    (0, di_1.Injectable)(di_1.Bootstrapper)
], OrmHttpBootstrapper);
//# sourceMappingURL=index.js.map