/// <reference types="cookie-parser" />
import { AsyncService, Constructor } from '@spinajs/di';
import { DeleteQueryBuilder, InsertQueryBuilder, ModelBase, SelectQueryBuilder, UpdateQueryBuilder } from '@spinajs/orm';
import * as express from 'express';
import { JsonApiIncomingObject } from './interfaces.js';
export declare abstract class RepositoryMiddleware extends AsyncService {
    onGetMiddlewareStart(_resource: any, _req: express.Request): Promise<void>;
    onGetAllMiddlewareStart(_req: express.Request): Promise<void>;
    onUpdateMiddlewareStart(_resource: any, _data: JsonApiIncomingObject, _req: express.Request): Promise<void>;
    onInsertMiddlewareStart(_data: JsonApiIncomingObject, _req: express.Request): Promise<void>;
    onDeleteMiddlewareStart(_resource: any, _req: express.Request): Promise<void>;
    onGetMiddlewareQuery(_query: SelectQueryBuilder<any>, _model: Constructor<ModelBase>, _req: express.Request): void;
    onGetAllMiddlewareQuery(_query: SelectQueryBuilder<any>, _model: Constructor<ModelBase>, _req: express.Request): void;
    onUpdateMiddlewareQuery(_resource: any, _query: UpdateQueryBuilder<any>, _model: Constructor<ModelBase>, _req: express.Request): void;
    onInsertMiddlewareQuery(_query: InsertQueryBuilder, _model: Constructor<ModelBase>, _req: express.Request): void;
    onDeleteMiddlewareQuery(_query: DeleteQueryBuilder<any>, _model: Constructor<ModelBase>, _req: express.Request): void;
    onGetMiddlewareResult(jsonData: any, _req: express.Request): any;
    onGetAllMiddlewareResult(jsonData: any, _req: express.Request): any;
    onInsertMiddlewareResult(jsonData: any, _req: express.Request): any;
    onUpdateMiddlewareResult(jsonData: any, _req: express.Request): any;
    onDeleteMiddlewareResult(_req: express.Request): void;
}
//# sourceMappingURL=middleware.d.ts.map