import { FilterableOperators, IColumnFilter, IFilter } from './interfaces.js';
declare module '@spinajs/orm' {
    interface IModelDescriptor {
        /**
         * If set column is fitlerable by this operators
         */
        FilterableColumns?: Map<string, FilterableOperators[]>;
    }
    interface ISelectQueryBuilder {
        /**
         *
         * Add filter to query
         *
         * @param filter
         */
        filter(filter: IFilter[]): this;
    }
    namespace ModelBase {
        /**
         * @returns json schema of filterable columns
         */
        function filterSchema(): any;
        function filterColumns(): IColumnFilter[];
        /**
         *
         * NOTE: this is not a part of orm, but a part of orm-http extension
         * NOTE 2: explicit type for generic T is not possible due to typescript limitations
         *         we cannot infer type of T from function arguments couse this is augumentation
         *
         * @param filters
         */
        function filter<T extends ModelBase<unknown>>(filters: IFilter[]): Promise<Array<T>>;
    }
}
//# sourceMappingURL=extension.d.ts.map