var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Inject, Injectable, Container } from '@spinajs/di';
import { RouteArgs } from '@spinajs/http';
let FilterModelRouteArg = class FilterModelRouteArg extends RouteArgs {
    constructor(c) {
        super();
        this.Container = c;
    }
    async resolve() { }
    get SupportedType() {
        return 'FilterModelRouteArg';
    }
    async extract(callData, _args, param, req, _res, route) {
        const filter = req.query[param.Name] ?? req.body?.[param.Name];
        // we extract route param schema extract, not dectorator
        // becouse mixins are not applied to model before controller init
        const rParam = {
            ...param,
            Schema: {},
        };
        // TODO: maybe cast fix ?
        // Check if constructor instead of array ?
        if (!Array.isArray(param.Options) && param.Options.filterSchema) {
            // get orm model schema
            rParam.Schema = param.Options.filterSchema();
        }
        else {
            // manually build custom schema
            rParam.Schema = {
                type: 'array',
                items: {
                    type: 'object',
                    anyOf: param.Options.map((x) => {
                        return {
                            type: 'object',
                            required: ['Column', 'Value', 'Operator'],
                            properties: {
                                Column: { const: x.Column },
                                Value: { type: ['string', 'integer', 'array'] },
                                Operator: { type: 'string', enum: x.Operators },
                            },
                        };
                    }),
                },
            };
        }
        let result = await this.tryHydrateParam(typeof filter === 'string' ? JSON.parse(filter) : filter, rParam, route);
        return { CallData: callData, Args: result };
    }
};
FilterModelRouteArg = __decorate([
    Injectable(),
    Inject(Container),
    __metadata("design:paramtypes", [Object])
], FilterModelRouteArg);
export { FilterModelRouteArg };
//# sourceMappingURL=route-arg.js.map